<?php

define('CM_VERSION','0.1.2.1');

/*
Plugin Name: CommentMailer
Plugin URI: http://sit.24stunden.de/cmailer
Description: CommentMailer notifies users of new comments to a subscribed posting.
Author: Sebastian Schwaner
Author URI: http://sit.24stunden.de/cmailer
Version: 0.1.2.1
*/


/* ----------------------------------------------------------------------------

© Copyright 2006  Sebastian Schwaner

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

---------------------------------------------------------------------------- */

# --- ADD FILTERS AND ACTIONS
add_action('admin_menu','cm_setGUI');
add_action('comment_post','cm_execute');

# --- FUNCTIONS

function cm_setGUI() {
   add_submenu_page( 'edit-comments.php','CommentMailer','CommentMailer',9,__FILE__,'cm_GUI' );
}

// BASIC FUNCTION FOR THE COMMENTS.PHP TEMPLATE
function setCommentMailer( $get ) {

     global $wpdb,$user_ID;
     $table = $wpdb->prefix."cmailer";

     // VERIFY SUBSCRIBING
     if( @$get['cmd'] == 'verify' ) :
          $post_id = @$get['post_id'];
          $email = @$get['email'];

          if( ! $post_id || ! $email ) :
               echo "<script type=\"text/javascript\">alert('Error on verifying subscribing!');</script>";
          else :
               $wpdb->query(" UPDATE $table SET status='ok' WHERE md5(post_id)='$post_id' AND md5(email)='$email' ");
          endif;
     endif;

     // UNSUBSCRIBE
     if( @$get['cmd'] == 'unsubscribe' ) :
          if( ! $id = @$get['id'] ) :
               echo "<script type=\"text/javascript\">alert('Error on unsubscribing!\nPlease contact support!');</script>";
          else :
               $wpdb->query(" DELETE FROM $table WHERE md5(id)='$id' ");
          endif;

     endif;

     if( ! $user_ID ) :
          echo "<p><input type=\"checkbox\" name=\"comment_notify\" value=\"1\"> Ja, ich möchte bei neuen Kommentaren benachrichtigt werden!</p>";
     endif;
}

function cm_execute( $id ) {

     global $wpdb;
     $table = $wpdb->prefix."cmailer";

     // IF USER WANT TO SUBSCRIBE
     if( @$_POST['comment_notify'] ) cm_subscribe( $id );

     $url = parse_url( get_option('home') );
     $from = "noreply@".$url['host'];
     $email = @$_POST['email'];

     $post_id = @$_POST['comment_post_ID'];
     $title = $wpdb->get_var(" SELECT post_title FROM $wpdb->posts WHERE ID=$post_id ");

     // SETTING SUBJECT
     $subject = $url['host'].": A new comment on \"$title\"";

     // GET LINK AND THE REQUIRED ENTITY
     $guid = $wpdb->get_var(" SELECT guid FROM $wpdb->posts WHERE ID=$post_id ");
     if( substr_count($guid,"?") > 0 ) $entity = "&"; else $entity = "?";

     // GET APPROVAL STAT
     $is_approved = $wpdb->get_var(" SELECT comment_approved FROM $wpdb->comments WHERE comment_ID = $id ");

     // GET ALL SUBSCRIBERS FROM DATABASE
     $subs = $wpdb->get_results(" SELECT * FROM $table WHERE post_id=$post_id AND status='ok' AND email != '$email' ");

     // DO ONLY IF COMMENT IS APPROVED
     if( $is_approved ) :
          // SEND EMAIL FOR EVERY SUBSCRIBER THAT IS VERIFIED AND NOT THE SENDER OF THE COMMENT
          foreach( $subs as $subs ) :
               $msg = "Hello,\n\nthere's a new comment to the posting \"$title\" on ".$url['host'].". To read it please click here\n\n$guid\n\nTo unsubscribe from this posting, please click here\n\n$guid".$entity."cmd=unsubscribe&id=".md5($subs->id)."\n\nSee you on ".$url['host']."\nThank You.\n\n";
               mail($subs->email,$subject,$msg,"From: noreply@".$url['host']."\nContent-type: text/plain; charset=UTF-8\n","-f red@24stunden.de");
          endforeach;

     endif;

}

// CREATES A TABLE IF TABLE NOT EXISTS
function cm_createTable() {
     global $wpdb;
     $table = $wpdb->prefix."cmailer";

     // DELETING OLD TABLE, CREATING NEW ONE
     $wpdb->query(" DROP TABLE $table ");
     $wpdb->query(" CREATE TABLE $table (id int(5) not null auto_increment, name varchar(100) not null, email varchar(255) not null, post_id bigint(20) not null, status enum('ok','wait') default 'wait' not null, primary key(id)) ");

     // SETTING TABLE VERSION
     $opt['table'] = '0.1.2';
     update_option('CM_OPTIONS',$opt);
}

function cm_subscribe( $id ) {
     global $wpdb;
     $table = $wpdb->prefix."cmailer";

     $url = parse_url( get_option('home') );
     $from = "noreply@".$url['host'];

     $nick = @$_POST['author'];
     $email = @$_POST['email'];

     $post_id = @$_POST['comment_post_ID'];
     $title = $wpdb->get_var(" SELECT post_title FROM $wpdb->posts WHERE ID=$post_id ");
     $subject = "Your subscribing to \"$title\"";

     // GET THE GUID-LINK AND THE ENTITY
     $guid = $wpdb->get_var(" SELECT guid FROM $wpdb->posts WHERE ID=$post_id ");
     if( substr_count($guid,"?") > 0 ) $entity = "&"; else $entity = "?";

     $is_approved = $wpdb->get_var(" SELECT comment_approved FROM $wpdb->comments WHERE comment_ID = $id ");
     $is_subscriber = $wpdb->get_var(" SELECT id FROM $table WHERE  email='$email' AND post_id=$post_id ");

     // IF COMMENT IS APPROVED AND IF SUBSCRIBER ISN'T ALWAYS SUBSCRIBED TO THIS POSTING
     if( $is_approved == 1 && ! $is_subscriber ) :
          $wpdb->query(" INSERT INTO $table VALUES ('','$nick','$email','$post_id','wait') ");
          $msg = "Please verify your subscribing to the weblog's post \"$title\" by clicking on the following link\n\n$guid".$entity."cmd=verify&post_id=".md5($post_id)."&email=".md5($email)."\n\nIf not, you'll not receiving any notifications on incoming comments.\n\nThank You.";
          // SEND VERIFYING-EMAIL TO SUBSCRIBER WITH VERIFYING-LINK
          mail($email,$subject,$msg,"From: $from\nContent-type: text/plain; charset=UTF-8\n","-f red@24stunden.de");
     endif;

}

// UNSUBSCRIBES A USER FROM POSTING
function cm_unsubscribe() {
     global $wpdb;
     $table = $wpdb->prefix."cmailer";

     if( ! $id = @$_GET['id'] ) :
          echo "<script type=\"text/javascript\">Error on unsubscribing! Posting not found!</script>";
          return;
     endif;

     $wpdb->query(" DELETE FROM $table WHERE md5(id) = '$id' ");

}

// UNSUBSCRIBE ALL USERS
function cm_unsubscribeAll() {
     global $wpdb;
     $table = $wpdb->prefix."cmailer";

     $wpdb->query(" DELETE FROM $table ");
     $wpdb->query(" OPTIMIZE TABLE $table ");
}

// GRAPHICAL OUTPUT
function cm_GUI() {

     global $wpdb;
     $table = $wpdb->prefix."cmailer";

     // IF POST OR GET ISSET
     if( @$_POST['cmd'] == 'createTable') cm_createTable();
     if( @$_GET['cmd'] == 'unsubscribe' ) cm_unsubscribe();
     if( @$_POST['cmd'] == 'unsubscribeAll' ) cm_unsubscribeAll();

     // GET TABLE VERSION
     $opt = get_option("CM_OPTIONS");

     // IF NO TABLE FOUND CREATE IT
     if( ! $wpdb->get_var(" DESCRIBE $table ") || $opt['table'] != '0.1.2' ) : ?>
     <div class="wpbody">
          <div class="wrap">
               <form method="post">
               <h2>Init database</h2>
               <p>It seems to be the first time the plugin runs or your table is running out of date. A newer table <b><?php echo $table; ?></b> must be created in your database.</p>
               <p><b>ATTENTION:</b> All data will be deleted after updating table.</p>
               <p><input type="submit" value="Create/Update required table now" class="button-secondary"></p>
               <input type="hidden" name="cmd" value="createTable">
               </form>
          </div>
     </div>

     <?php else : ?>

     <?php // OUTPUT OF ALL SUBSCRIBED POSTINGS ?>
     <?php if( empty($_GET['site']) ) $site = 0; else $site = $_GET['site'] * 10; ?>
     <?php $subs = $wpdb->get_results(" SELECT * from $table WHERE 1 ORDER BY id DESC LIMIT $site,10 "); ?>
     <?php $count = $wpdb->get_var(" SELECT COUNT(*) from $table WHERE 1 "); ?>

     <div class="wpbody">
          <div class="wrap">
               <h2>Subscribed postings</h2>
               <p>Here's the list of all users that subscribed one or more postings from your weblog. You're able to unsubscribe users from a single posting or to delete all subscribings.</p>

               <?php // IF SUBSCRIBERS FOUND ?>
               <?php if( $subs ) : ?>

               <?php // PAGES ?>
               <div class="tablenav">
                    <b>Pages:</b>
                    <?php if( $count%10 == 0 ) $pages=$count/10; else $pages=floor($count/10)+1; ?>
                    <?php for($i=0;$i<$pages;$i++) : ?>
                    <a href="?page=cmailer/cmailer.php&site=<?php echo $i; ?>" style="padding:5px; font-weight:bold; <?php if( @$_GET['page'] == $i ) echo "color:#333;"; ?>"><?php echo $i+1; ?></a>
                    <?php endfor; ?>
               </div><br/>

               <table class="widefat">
                    <thead>
                         <tr>
                              <th scope="col">ID</th>
                              <th scope="col">Posting</th>
                              <th scope="col">Nick</th>
                              <th scope="col">Actions</th>
                         </tr>
                    </thead>
                    <tbody>
                         <?php foreach( $subs as $subs ) : ?>
                         <tr class="comment">
                              <td>
                                   <?php echo $subs->post_id; ?>
                              </td>
                              <td>
                                   <a href="<?php echo $wpdb->get_var(" SELECT guid FROM $wpdb->posts WHERE ID=$subs->post_id "); ?>">
                                   <?php echo $wpdb->get_var(" SELECT post_title FROM $wpdb->posts WHERE ID=$subs->post_id "); ?>
                                   </a>
                              </td>
                              <td>
                                   <a href="mailto:<?php echo $subs->email; ?>"><?php echo $subs->name; ?></a>
                              </td>
                              <td>
                                   <a href="?page=cmailer/cmailer.php&cmd=unsubscribe&id=<?php echo md5($subs->id); ?>">Unsubscribe</a>
                              </td>
                         </tr>
                         <?php endforeach; ?>
                    </tbody>
               </table>
               <div class="tablenav">
                    <form method="post">
                    <input type="hidden" name="cmd" value="unsubscribeAll">
                    <input type="submit" value="Unsubscribe all users" class="button-secondary" onlick="return confirm('Are you sure to unsubscribe all users?');">
                    </form>
               </div>

               <br/>

               <?php else : ?><p><b>Sorry, no subscribers found yet!</b></p><?php endif; ?>

               <p>&copy; Copyright 2008 by sit. small it-solutions.<br/>
               This Wordpress weblog uses <b><a href="http://sit.24stunden.de/cmailer/">CommentMailer-<?php echo CM_VERSION; ?></a> &raquo;</b></p>

          </div>
     </div>

     <?php endif; ?>
     <?php } ?>